
package de.ivu.elect.business.dokumente.control;

import static de.ivu.elect.business.wahl.entity.WahlOderWahltermin.from;

import java.io.Serializable;
import java.util.Locale;
import java.util.TimeZone;

import javax.annotation.Nullable;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.exchange.control.AbstractContextMitCustomParameter;
import de.ivu.elect.business.exchange.control.ContextMitCustomParameter;
import de.ivu.elect.business.mandant.entity.Mandant;
import de.ivu.elect.business.person.entity.Geschlecht;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahl.entity.WahlOderWahltermin;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.jee.faces.Messages;

public class ElectDokumentContext extends AbstractContextMitCustomParameter implements Serializable, ContextMitCustomParameter {

  private static final long serialVersionUID = 1L;

  private final Benutzer benutzer;

  private final Locale locale;

  private final TimeZone timeZone;

  private final Messages messages;

  private final Wahl wahl;

  private final Wahltermin wahltermin;

  public ElectDokumentContext(ElectDokumentContext other) {
    this(other.getBenutzer(), other.getLocale(), other.getTimeZone(), other.getMessages(), other.getWahltermin(), other.getWahl());

    this.contextParameters.putAll(other.getContextParameters());
  }

  public ElectDokumentContext(Benutzer benutzer, Locale locale, TimeZone timeZone, Messages messages, @Nullable Wahltermin wahltermin, @Nullable Wahl wahl) {
    super();

    this.benutzer = benutzer;

    this.locale = locale;
    this.timeZone = timeZone;
    this.messages = messages;

    this.wahltermin = wahltermin;
    this.wahl = wahl;
  }

  public Benutzer getBenutzer() {
    return benutzer;
  }

  public TimeZone getTimeZone() {
    return timeZone;
  }

  public Messages getMessages() {
    return messages;
  }

  public Locale getLocale() {
    return locale;
  }

  public String getMessage(Boolean value) {
    return getMessages().lokalisiere(value);
  }

  public String getMessage(Enum< ? > enumValue) {
    return getMessages().lokalisiere(enumValue);
  }

  public String getMessageGendered(Enum< ? > enumValue, Geschlecht geschlecht) {
    return getMessages().lokalisiere(enumValue, geschlecht);
  }

  public String getMessage(String msgKey, Object... params) {
    return getMessages().getMessageForMessageKey(msgKey, params);
  }

  public Wahl getWahl() {
    return wahl;
  }

  public Wahltermin getWahltermin() {
    return wahltermin;
  }

  public WahlOderWahltermin getWahlOderWahltermin() {
    return from(getWahltermin(), getWahl());
  }

  public Mandant getMandant() {
    return getBenutzer().getMandant();
  }
}
